Very small persistent cache-size -> non-speaking assertion error

Bug #440398 reported by Andreas Jung on 2009-10-02
6
This bug affects 1 person
Affects Status Importance Assigned to Milestone
ZODB
Undecided
Unassigned

Bug Description

Through a configuration mistake we had a configured cache-size of 20 byte for a mounted temporary storage

<zodb_db temporary>
    mount-point /temp_folder
    cache-size 5000
    pool-size 4
    <zeoclient>
        storage temp_dev
        cache-size 20 # <!-------------
        server 10.7.1.2:4711
    </zeoclient>
</zodb_db>

This resulted in the following non-speaking assertion error:

2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17

Time 2009/10/02 07:18:39.724152 GMT+2
User Name (User Id) ajung (ajung)
Request URL http://hdev:8080/Test/HaufeCMS/loginAction
Exception Type AssertionError
Exception Value

Traceback (innermost last):

Module ZPublisher.Publish, line 134, in publish
Module Zope2.App.startup, line 270, in commit
Module transaction._manager, line 93, in commit
Module transaction._transaction, line 325, in commit
Module transaction._transaction, line 432, in _commitResources
Module ZODB.Connection, line 753, in tpc_finish
Module ZEO.ClientStorage, line 1187, in tpc_finish
Module ZEO.ClientStorage, line 1212, in _update_cache
Module ZEO.cache, line 375, in invalidate

Perhaps there should be some better check (e.g. a check for a minimum cache-size)

On Fri, Oct 2, 2009 at 2:56 AM, Andreas Jung <email address hidden> wrote:
> Public bug reported:
>
> Through a configuration mistake we had a configured cache-size of 20
> byte for a mounted temporary storage

What version of ZODB?

>
> <zodb_db temporary>
>    mount-point /temp_folder
>    cache-size  5000
>    pool-size   4
>    <zeoclient>
>        storage      temp_dev
>        cache-size   20                         # <!-------------
>        server       10.7.1.2:4711
>    </zeoclient>
> </zodb_db>
>
> This resulted in the following non-speaking assertion error:
>
>
> 2
> 3
> 4
> 5
> 6
> 7
> 8
> 9
> 10
> 11
> 12
> 13
> 14
> 15
> 16
> 17

I don't know what the above is supposed to be.

>
> Time 2009/10/02 07:18:39.724152 GMT+2
> User Name (User Id) ajung (ajung)
> Request URL http://hdev:8080/Test/HaufeCMS/loginAction
> Exception Type AssertionError
> Exception Value
>
> Traceback (innermost last):
>
> Module ZPublisher.Publish, line 134, in publish
> Module Zope2.App.startup, line 270, in commit
> Module transaction._manager, line 93, in commit
> Module transaction._transaction, line 325, in commit
> Module transaction._transaction, line 432, in _commitResources
> Module ZODB.Connection, line 753, in tpc_finish
> Module ZEO.ClientStorage, line 1187, in tpc_finish
> Module ZEO.ClientStorage, line 1212, in _update_cache
> Module ZEO.cache, line 375, in invalidate

There's no assertion error on line 375 on either the 3.8 or 3.9 branches.

>
> Perhaps there should be some better check (e.g. a check for a minimum cache-size)

In ZODB 3.9, it is legal to have a cache size of 0.

Jim

--
Jim Fulton

Andreas Jung (ajung) wrote :

ZODB 3.8 or 3.8.1

Jim Fulton (jim-zope) wrote :

This was fixed in 3.9

Changed in zodb:
status: New → Fix Committed
Changed in zodb:
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers